
var ifInDestructionPhase : boolean = false;
private var startinFrameNumber : int;

var material1 : Material;
var material2 : Material;
var material3 : Material;

var scaleC1 : float;
var scaleC2 : float;
var scaleC3 : float;

function Update()
{
	if(ifInDestructionPhase)
	{
		if( Time.frameCount - startinFrameNumber ==1 )
		{
			this.transform.localScale *= scaleC1;
			this.renderer.material =  material1;
			
		}
		else
		{
			if( Time.frameCount - startinFrameNumber ==6 )
			{
				this.transform.localScale *= scaleC2;
				this.renderer.material =  material2;
			}
			else
			{
				if( Time.frameCount - startinFrameNumber ==13 )
				{
					this.transform.localScale *= scaleC3;
					this.renderer.material =  material3;
				}
				else
				{
					if( Time.frameCount - startinFrameNumber ==17 )
					{
						Destroy(this.gameObject);
					}
				}
				
			}
		}
	}
	else
	{
		if(this.transform.position.magnitude > 17)
		{
			//Destroy(this.gameObject);
		}
	}
}
function OnTriggerEnter( coll : Collider)
{
	if(!ifInDestructionPhase)
	{
		if( coll.tag=="obstacle" )
		{
			Destroy(this.gameObject);
		}
		if( coll.tag=="enemy" )
		{
			
			GameObject.Find("character").GetComponent.<characterController>().Score +=10 * coll.transform.localScale.x;
			Destroy(coll.gameObject);
			Destroy(this.gameObject);
			
		}
	}
}

function OnTriggerExit( coll : Collider)
{
	if(!ifInDestructionPhase)
	{
		if( coll.tag=="crazinessField" )
		{
			this.collider.enabled = false;
			this.GetComponent.<TrailRenderer>().enabled = false;
			this.rigidbody.isKinematic = true;
			ifInDestructionPhase = true;
			startinFrameNumber = Time.frameCount;
		}
	}
}