var gameOverObject : GameObject;
private var GuiManagerScript : GuiManager;
private var enemyGeneratorScript : enemyGenerator;
private var cameraTransform : Transform;
var charaacterMainMaterial : Material;
var haloGameObject : GameObject;
var triggerGameObject : GameObject;
var characterTextObject : GameObject;
var characterTextObjectCloud : GameObject;
private var characterTextObjectmesh : TextMesh;

private var canFire : boolean = false;

var numberOfEnemyMeets : int = 0;
private var lastTimeCharacterTextChanged : int;
var CharactertextLifeTime : int;

var Speed : float;
var ConstSpeed : float;

var xMinAndMax : Vector2;
var yMinAndMax : Vector2;
var CameraMaxDistance : Vector2;

var walkingSpeed : float;
private var walkingDirection : Vector3;
private var ifInMobileModeIsMoving : boolean = false;
private var InMobileModeIsMovingTouchNest : int;
var touchCoordinates : float;

private var newBullet : Transform;
var BulletRefrence : Transform;
private var bulletScaleFinalConst : float = 1;
var BulletVelocity : float;
var bulletFireRate : float;
private var bulletFireTime : float;
private var lastTimeBulletWasFired :float;



var MousePointer : Transform;
var cameraObject : GameObject;
private var cameraSize : float = 20;
private var aspectRatio : float;
private var currentWidth : float; 
private var currentXLength : float;

private var characterRotationVector : Vector3;
private var characterRotationAngle : float;


private var gameStartTime : float;
var Hp : float = 300;
var HpMax : float = 300;
var Ammo : float = 1000;
var Score : float;

private var trail : TrailRenderer;

var firingAudioClip : AudioClip;

var minAndMaxOfXAxis : Vector2 ;
 var XaxisAmount : int = 0;
private var previouseFrameXaxisAmount : int;
var scaleFoodEffectOnScale : float = .75;
var scaleFoodEffectOnBulletScale : float=.5;
var speedFoodEffectOnWalkingSpeed : float = .5;
var speedFoodEffectOnFiringRate : float = 1;

var minAndMaxOfYAxis : Vector2 ;
 var YaxisAmount : int = 0;
private var previouseFrameYaxisAmount : int;

var animationArray3 = new Material[7];
var animationArray2 = new Material[7];
var animationArray1 = new Material[7];
var animationArray0 = new Material[7];
var animationArray_1 = new Material[7];
var animationArray_2 = new Material[7];
var animationArray_3 = new Material[7];


var EanimationArray3 = new Material[7];
var EanimationArray2 = new Material[7];
var EanimationArray1 = new Material[7];
var EanimationArray0 = new Material[7];
var EanimationArray_1 = new Material[7];
var EanimationArray_2 = new Material[7];
var EanimationArray_3 = new Material[7];


function bulletFiringTimeCalculator()
{
	if( bulletFireRate >=1 )
	{
		bulletFireTime = 1/bulletFireRate;
	}
	else
	{
		bulletFireRate=1;
		bulletFireTime = 1/bulletFireRate;
	}
		
}

function Awake()
{
	if( (Application.platform == RuntimePlatform.WindowsEditor) || ( Application.platform == RuntimePlatform.WindowsPlayer) || (Application.platform == RuntimePlatform.Android) )
	{
		GuiManagerScript = this.GetComponent.<GuiManager>();
		enemyGeneratorScript = this.GetComponent.<enemyGenerator>();
		cameraTransform = GameObject.Find("Main Camera").transform;
		characterTextObjectmesh = characterTextObject.GetComponent.<TextMesh>();
		//haloGameObject = GameObject.Find("halo").gameObject;
		//triggerGameObject =GameObject.Find("trigger").gameObject;
		
		cameraSize = cameraObject.camera.orthographicSize;
		cameraObject.camera.aspect =1.7777777 ;
		aspectRatio = cameraObject.camera.aspect;
		currentXLength = cameraSize * aspectRatio;
		
		bulletFiringTimeCalculator();
		
		//Screen.showCursor = false;
		//Screen.lockCursor = true;
		
		gameStartTime = Time.time;
		trail = this.GetComponent.<TrailRenderer>();
		//Screen.showCursor = false;
		
		audio.clip = firingAudioClip;
	}
}



function mousePositioning()
{
	if( (Application.platform == RuntimePlatform.WindowsEditor) || ( Application.platform == RuntimePlatform.WindowsPlayer) )
	{
		MousePointer.position.x = cameraTransform.position.x+( 2 * currentXLength *(Input.mousePosition.x / Screen.width) ) - currentXLength;
		MousePointer.position.y = cameraTransform.position.y+( 2 * cameraSize * (Input.mousePosition.y / Screen.height) ) - cameraSize;
	}
	
}

function touchPositioning(touchPosition : Vector2)
{
	if( (Application.platform == RuntimePlatform.Android) )
	{
		MousePointer.position.x = ( 2 * (8 * 16 /9) *(touchPosition.x / Screen.width) ) - (8 * 16 /9);
		MousePointer.position.y = ( 2 * 8 * (touchPosition.y / Screen.height)  ) - 8;
	}
}

function characterRotation()

{
	characterRotationVector = MousePointer.position - this.transform.position;
	if(characterRotationVector.y >= 0)
	{
		characterRotationAngle = Vector3.Angle(characterRotationVector , Vector3(1,0,0));
	}
	else
	{
		characterRotationAngle =360 -  Vector3.Angle(characterRotationVector , Vector3(1,0,0));
	}
	this.transform.rotation.eulerAngles.z = characterRotationAngle;
	
}

function Update () 
{
	//characterTextObject.transform.position = this.transform.position+ Vector3(2.9,1.15 , -1);
	characterTextObject.transform.position = this.transform.position+ Vector3(this.transform.localScale.x *1.15 ,this.transform.localScale.x , -1);
	if(Hp <= 0 )
	{
		//Destroy(this.gameObject);
		this.enabled = false;
		
		characterTextObjectmesh.text = "AauGhh..GH...";
		lastTimeCharacterTextChanged = Time.frameCount;
		characterTextObjectCloud.renderer.enabled = true;
		
		gameOverObject.transform.position = this.transform.position;
		gameOverObject.transform.position.z = -9;
		gameOverObject.active = true;
		//GuiManagerScript.ifShowAntThing = false;
		
		
		Time.timeScale = 0;
		
	}
	else
	{
		Score += .1 * (Time.deltaTime) ;
	}
	if( (Application.platform == RuntimePlatform.WindowsEditor) || ( Application.platform == RuntimePlatform.WindowsPlayer) )
	{
		if(Hp > 0 )
		{
			pcType1();
			
		
			characterDialog();
		}
	}
	
	previouseFrameXaxisAmount = XaxisAmount;
}

function pcType1()
{
		audiopanSetter();
		mousePositioning();
		characterRotation();
		
		//CameraMaxDistance
		
		if( Input.GetKey(KeyCode.UpArrow) || Input.GetKey("w") )
		{
			if( yMinAndMax.y > this.transform.position.y )
			{
				if( Mathf.Abs( this.transform.position.y+Speed - cameraTransform.position.y) >= CameraMaxDistance.y)  
				{
					cameraTransform.position.y += Speed;
				}
				this.transform.position.y += Speed;
			}
		}
		if( Input.GetKey(KeyCode.DownArrow) || Input.GetKey("s"))
		{
			if( yMinAndMax.x < this.transform.position.y )
			{
				if( Mathf.Abs( this.transform.position.y-Speed - cameraTransform.position.y) >= CameraMaxDistance.y) 
				{
					cameraTransform.position.y -= Speed;
				}
				this.transform.position.y -= Speed;
			}
		}
		if( Input.GetKey(KeyCode.RightArrow)|| Input.GetKey("d") )
		{
			if( xMinAndMax.y > this.transform.position.x )
			{
				if( Mathf.Abs( this.transform.position.x+Speed - cameraTransform.position.x) >= CameraMaxDistance.x) 
				{
					cameraTransform.position.x += Speed;
				}
				this.transform.position.x += Speed;
			}
		}
		if( Input.GetKey(KeyCode.LeftArrow) || Input.GetKey("a"))
		{
			if( xMinAndMax.x < this.transform.position.x )
			{
				if( Mathf.Abs( this.transform.position.x-Speed - cameraTransform.position.x) >= CameraMaxDistance.x) 
				{
					cameraTransform.position.x -= Speed;
				}
				this.transform.position.x -= Speed;
			}
		}
		
		if( Input.GetButton("Fire1") )
		{	
			if(canFire)
			{
				if(Ammo >0)
				{
					if(Time.time - lastTimeBulletWasFired >= bulletFireTime)
					{
						newBullet = Instantiate( BulletRefrence , this.transform.position , this.transform.rotation );
						newBullet.transform.localScale *= bulletScaleFinalConst;
						newBullet.GetComponent.<TrailRenderer>().startWidth = newBullet.transform.localScale.x;
						newBullet.rigidbody.velocity = characterRotationVector.normalized * BulletVelocity;
						//newBullet.rotation.eulerAngles.y = characterRotationAngle;
						lastTimeBulletWasFired = Time.time;
						--Ammo;
						firingSoundPlay();
						//newBullet.rigidbody.velocity.y = Mathf.Sin(Mathf.Deg2Rad * this.transform.eulerAngles.z) * BulletVelocity;
						//newBullet.rigidbody.velocity.x = Mathf.Cos(Mathf.Deg2Rad * this.transform.eulerAngles.z) * BulletVelocity;
					}
				}
			}
			
		}
}

function OnTriggerEnter( coll : Collider)
{
	//Debug.Log( coll.tag);
	//if( coll.tag=="friend" )
	if(false)
	{
		
	}
	else
	{
	
		if( coll.tag=="enemy" )
		{
			//if( (this.transform.position - coll.transform.position).magnitude < 2)
			Destroy(coll.gameObject);
			Hp -=10;
			if(true)
			{
				if(this.transform.localScale.x > coll.transform.localScale.x)
				{
					
				}
				else
				{
				
					
				}
				
			}
			else
			{
			
			}
			if( (this.transform.position - coll.transform.position).magnitude < 1.5)
			{
				
			}
			
		}
		else
		{
			if( coll.tag=="food_ammo" )
			{
				Ammo += 1000 * coll.transform.localScale.x;
				Destroy(coll.gameObject);
			}
			else
			{
				
				if( coll.tag=="food_speed" )
				{
					
					if(minAndMaxOfXAxis.x < XaxisAmount)
					{
						foodSpeeding(1,coll);
						foodScaling(-1,coll);
						
						XaxisAmount -= 1;
						//animationSetter();
					}
					
					Destroy(coll.gameObject);
				}
				else
				{
					if( coll.tag=="food_scaler" )
					{
						
						if(minAndMaxOfXAxis.y > XaxisAmount)
						{
							foodSpeeding(-1,coll);
							foodScaling(1,coll);
						
							XaxisAmount += 1;
							//animationSetter();
						}
						
						Destroy(coll.gameObject);
					}
					else
					{
						if( coll.tag=="food_health" )
						{
							if(minAndMaxOfYAxis.y > YaxisAmount)
							{
							
								YaxisAmount += 1;
								//animationSetter();
							}
							Destroy(coll.gameObject);
						}
						else
						{
							if( coll.tag=="food_ability" )
							{
								if(minAndMaxOfYAxis.x < YaxisAmount)
								{
									
									YaxisAmount -= 1;
									//animationSetter();
								}
								Destroy(coll.gameObject);
							}
							else
							{
								if( coll.tag=="food_infection")
								{
									foodInfection();
									Destroy(coll.gameObject);
									/*
									characterTextObjectmesh.text = "my birthday GUESTS!";
									GuiManagerScript.ifShowAntThing = true;
									enemyGeneratorScript.ifGenerate = true;
									GameObject.Find("Main Camera").GetComponent.<musicManager>().ifplay = true;
									*/
								}
							}
						}
					}
				}
			}
		}
	}
}

function characterDialog()
{
	if( Ammo == 40 )
	{
		characterTextObjectmesh.text = "i need ammo";
		lastTimeCharacterTextChanged = Time.frameCount;
		characterTextObjectCloud.renderer.enabled = true;
	}
	switch(numberOfEnemyMeets)
	{
		case 1 :
			characterTextObjectmesh.text = "what?? zombies?";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 4 :
			characterTextObjectmesh.text = "i should kill them";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 8 :
			characterTextObjectmesh.text = "noo jane! no :((";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 12 :
			characterTextObjectmesh.text = "guys...it's me!hey!";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 19 :
			characterTextObjectmesh.text = "what's wrong with you?";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 25 :
			characterTextObjectmesh.text = "hey! stop it! stop!";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 32 :
			characterTextObjectmesh.text = "anyone hear me?";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 40 :
			characterTextObjectmesh.text = "they're all Sick...";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 52 :
			characterTextObjectmesh.text = "mom...it's not you!";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 63 :
			characterTextObjectmesh.text = "i don't wanna die";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 72 :
			characterTextObjectmesh.text = "you die....DIE";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 80 :
			characterTextObjectmesh.text = "sorry matt...sorry";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 89 :
			characterTextObjectmesh.text = ":(";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 94 :
			characterTextObjectmesh.text = ":((";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 98 :
			characterTextObjectmesh.text = ":(((";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 102 :
			characterTextObjectmesh.text = ";((((";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 105 :
			characterTextObjectmesh.text = ";((((";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 115 :
			characterTextObjectmesh.text = "ok,LET'S FINISH THIS!";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 124 :
			characterTextObjectmesh.text = ">:(";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 127 :
			characterTextObjectmesh.text = ">:((";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 131 :
			characterTextObjectmesh.text = ">:(((";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 138 :
			characterTextObjectmesh.text = "daddy,mom...bro...";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 144 :
			characterTextObjectmesh.text = "jane, ,matt..";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 149 :
			characterTextObjectmesh.text = "kim, and you!";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 153 :
			characterTextObjectmesh.text = "yes...YOU!";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
		case 160 :
			characterTextObjectmesh.text = "i'll kill you all";
			lastTimeCharacterTextChanged = Time.frameCount;
			characterTextObjectCloud.renderer.enabled = true;
			break;
			
	}
	
	if( CharactertextLifeTime <= (Time.frameCount - lastTimeCharacterTextChanged) )
	{
		characterTextObjectmesh.text = "";
		characterTextObjectCloud.renderer.enabled = false;
	}
}

function foodScaling( scalingConst : int , coll : Collider)
{
	/*
	this.transform.localScale.x += scalingConst * scaleFoodEffectOnScale  *  coll.transform.localScale.x;
	this.transform.localScale.y += scalingConst * scaleFoodEffectOnScale  *  coll.transform.localScale.x;
	bulletScaleFinalConst += scalingConst * scaleFoodEffectOnBulletScale;
	*/
	this.transform.localScale.x += scalingConst * scaleFoodEffectOnScale ;
	this.transform.localScale.y += scalingConst * scaleFoodEffectOnScale ;
	//bulletScaleFinalConst += scalingConst * scaleFoodEffectOnBulletScale;
	bulletScaleFinalConst = scalingConst * bulletScaleFinalConst * this.transform.localScale.x / (this.transform.localScale.x-scalingConst * scaleFoodEffectOnScale);
}

function foodSpeeding(scalingConst : int , coll : Collider)
{
	Speed += scalingConst * speedFoodEffectOnWalkingSpeed;
	bulletFireRate += scalingConst * speedFoodEffectOnFiringRate;
	bulletFiringTimeCalculator();
}

function foodAbility()
{
}

function foodHealth( increaseOrDecrease : boolean)
{
	if(increaseOrDecrease)
	{
		Hp += 75; 
	}
	else
	{
		Hp -= 75; 
	}
	
}

function foodInfection()
{
	canFire = true;
	haloGameObject.active = true;
	triggerGameObject.active = true;
	
	characterTextObjectmesh.text = "my birthday GUESTS!";
	GuiManagerScript.ifShowAntThing = true;
	enemyGeneratorScript.ifGenerate = true;
	GameObject.Find("Main Camera").GetComponent.<musicManager>().ifplay = true;
	this.renderer.material = charaacterMainMaterial;
	
}

function firingSoundPlay()
{
	
	audio.Play();
}

function audiopanSetter()
{
	audio.pan = this.transform.position.x / 12.5;
}

function animationSetter()
{
	/*switch(YaxisAmount)
	{
		case 3:
			this.renderer.material = animationArray3[(XaxisAmount+3)];
			//enemyGeneratorScript.enemiesArtController(  EanimationArray3[(XaxisAmount+3)] );
			
			break;
		case 2:
			this.renderer.material = animationArray2[(XaxisAmount+3)];
			//enemyGeneratorScript.enemiesArtController(  EanimationArray2[(XaxisAmount+3)] );
			
			break;
		case 1:
			this.renderer.material = animationArray1[(XaxisAmount+3)];
			//enemyGeneratorScript.enemiesArtController(  EanimationArray1[(XaxisAmount+3)] );
			
			break;
		case 0:
			this.renderer.material = animationArray0[(XaxisAmount+3)];
			enemyGeneratorScript.enemiesArtController(  EanimationArray0[(XaxisAmount+3)] );
			
			break;
		case -1:
			this.renderer.material = animationArray_1[(XaxisAmount+3)];
			enemyGeneratorScript.enemiesArtController(  EanimationArray_1[(XaxisAmount+3)] );
			
			break;
		case -2:
			this.renderer.material = animationArray_2[(XaxisAmount+3)];
			enemyGeneratorScript.enemiesArtController(  EanimationArray_2[(XaxisAmount+3)] );
			
			break;
		case -3:
			this.renderer.material = animationArray_3[(XaxisAmount+3)];
			enemyGeneratorScript.enemiesArtController(  EanimationArray_3[(XaxisAmount+3)] );
			
			break;
		
	}\
	*/
	
}

function backgroundAnimationChanger()
{
}

