
private var characterControllerScript : characterController;
private var enemyGeneratorScript : enemyGenerator;

function Awake()
{
	characterControllerScript = this.transform.parent.GetComponent.<characterController>();
	enemyGeneratorScript = this.transform.parent.GetComponent.<enemyGenerator>();
}

function OnTriggerEnter( coll : Collider)
{
	if( coll.tag=="friend" )
	{
		characterControllerScript.numberOfEnemyMeets += 1;
		enemyGeneratorScript.peopleChecker(coll.gameObject);
	}
}

function OnTriggerExit( coll : Collider)
{
	if( coll.tag=="enemy" )
	{
		characterControllerScript.numberOfEnemyMeets += 1;
		enemyGeneratorScript.peopleChecker(coll.gameObject);
	}
}