private var characterControllerComponent : characterController;
var enemyRefrence : Transform;
var enemyGenerationRate : float;
var enemyGenerationRateChangeSpeed : float;
private var enemyGenerationTime : float;
private var lastTimeAnEnemyWasCreated : float;
static var ifGenerate : boolean = false;
private var newEnemy : Transform;
private var RandomeNum : Vector2;
var minAndMaxOfScaleRandomizing : Vector2;
private var randomeFloatNum : float;


private var mainCharacterScale : Vector3;

var enemySentecnesArray_1 = new String[0];
var enemiesArray = new Transform[0];

var texmesh_1 : TextMesh;
var texmesh_2 : TextMesh;
var texmesh_3 : TextMesh;

var textRef_1 : Transform;
var textRef_2 : Transform;
var textRef_3: Transform;



var sentenceRef_1 : Transform;
var sentenceRef_2 : Transform;
var sentenceRef_3 : Transform;

var enemySentecnesArray_2 = new String[0];

var texmesh_R_1 : TextMesh;
var texmesh_R_2 : TextMesh;
var texmesh_R_3 : TextMesh;

var textRef_R_1 : Transform;
var textRef_R_2 : Transform;
var textRef_R_3: Transform;



var sentenceRef_R_1 : Transform;
var sentenceRef_R_2 : Transform;
var sentenceRef_R_3 : Transform;

private var lastTimeTextWasSet : int;

var delayBetweanTexting : int;

function Awake()
{
	characterControllerComponent = this.GetComponent.<characterController>();
	texmesh_1 = textRef_1.GetComponent.<TextMesh>();
	texmesh_2 = textRef_2.GetComponent.<TextMesh>();
	texmesh_3 = textRef_3.GetComponent.<TextMesh>();
	
	texmesh_R_1 = textRef_R_1.GetComponent.<TextMesh>();
	texmesh_R_2 = textRef_R_2.GetComponent.<TextMesh>();
	texmesh_R_3 = textRef_R_3.GetComponent.<TextMesh>();
	
	enemyGenerationTime = 1/enemyGenerationRate;
}
function Update()
{
	mainCharacterScale = this.transform.localScale;
	if(ifGenerate)
	{
		enemyGenerator();
		peopleSntences();
		peopleUpdate_R();
	}
}
function enemyGenerationPropertyChangeSpeed()
{
	enemyGenerationRate += enemyGenerationRateChangeSpeed ;
	enemyGenerationTime = 1/enemyGenerationRate;
}

function enemyGenerator()
{
	RandomeNum = Random.insideUnitCircle;
	randomeFloatNum = Random.Range( minAndMaxOfScaleRandomizing.x ,  minAndMaxOfScaleRandomizing .y  );
	//Debug.Log( RandomeNum );
	if(Time.time - lastTimeAnEnemyWasCreated >= enemyGenerationTime)
	{
		newEnemy = Instantiate( enemyRefrence , RandomeNum*40 , this.transform.rotation );
		if(true)
		{
			newEnemy.transform.localScale.x = randomeFloatNum * mainCharacterScale.x;
			newEnemy.transform.localScale.y = randomeFloatNum * mainCharacterScale.y;
			newEnemy.transform.localScale.z = randomeFloatNum * mainCharacterScale.z;
		}
		
		lastTimeAnEnemyWasCreated = Time.time;
		enemyGenerationPropertyChangeSpeed();
		
		for(var counter:int=0;counter< enemiesArray.Length; ++counter)
		{
			if( enemiesArray[counter] == null )
			{
				enemiesArray[counter] = newEnemy.transform;
				counter = enemiesArray.Length;
			}
		}
	}
}

function peopleChecker( givenObject : GameObject)
{
	if(sentenceRef_1)
	{
		if(givenObject.transform.position == sentenceRef_1.transform.position)
		{
			sentenceRef_1 = null;
		}
	}
	if(sentenceRef_2)
	{
		if(givenObject .transform.position== sentenceRef_2.transform.position)
		{
			sentenceRef_2 = null;
		}
		
	}
	if(sentenceRef_3)
	{
		if(givenObject.transform.position == sentenceRef_3.transform.position)
		{
			sentenceRef_3 = null;	
		}
	}		
	
	if(sentenceRef_R_1)
	{
		if(givenObject.transform.position == sentenceRef_R_1.transform.position)
		{
			sentenceRef_R_1 = null;
		}
	}
	if(sentenceRef_R_2)
	{
		if(givenObject .transform.position== sentenceRef_R_2.transform.position)
		{
			sentenceRef_R_2 = null;
		}
		
	}
	if(sentenceRef_R_3)
	{
		if(givenObject.transform.position == sentenceRef_R_3.transform.position)
		{
			sentenceRef_R_3 = null;	
		}
	}
}

function peopleUpdate_R()
{
	if( sentenceRef_R_1 != null)
	{
		textRef_R_1.transform.position = sentenceRef_R_1.position + Vector3((sentenceRef_R_1.position - this.transform.position).normalized.x * sentenceRef_R_1.localScale.x*.7, (sentenceRef_R_1.position - this.transform.position).normalized.y*.7 * sentenceRef_R_1.localScale.x , -1) ;
		textRef_R_1.transform.rotation = sentenceRef_R_1.rotation;
	}
	if( sentenceRef_R_2 != null)
	{
		textRef_R_2.transform.position = sentenceRef_R_2.position + Vector3((sentenceRef_R_2.position - this.transform.position).normalized.x * sentenceRef_R_2.localScale.x*.7, (sentenceRef_R_2.position - this.transform.position).normalized.y*.7 * sentenceRef_R_2.localScale.x , -5) ;
		textRef_R_2.transform.rotation = sentenceRef_R_2.rotation;
	}
	if( sentenceRef_R_3 != null)
	{
		textRef_R_3.transform.position = sentenceRef_R_3.position + Vector3((sentenceRef_R_3.position - this.transform.position).normalized.x *.7* sentenceRef_R_3.localScale.x, (sentenceRef_R_3.position - this.transform.position).normalized.y*.7 * sentenceRef_R_3.localScale.x , -5) ;
		textRef_R_3.transform.rotation = sentenceRef_R_3.rotation;
	}
	
	if( sentenceRef_R_1 == null)
	{
		textRef_R_1.transform.position = Vector3(100,100,0);
	}
	if( sentenceRef_R_2 == null)
	{
		textRef_R_2.transform.position = Vector3(100,100,0);
	}
	if( sentenceRef_R_3 == null)
	{
		textRef_R_3.transform.position = Vector3(100,100,0);
	}
	
}

function peopleSntences_R( givenObject : GameObject)
{
	var i : int;
	//Debug.Log("0");
	if(true)
	{
		
		if( sentenceRef_R_1 == null)
		{
			if( (((Time.frameCount - lastTimeTextWasSet) >= delayBetweanTexting)) && (givenObject != null))
			{
				lastTimeTextWasSet = Time.frameCount;
				sentenceRef_R_1 = givenObject.transform;
				givenObject=null;
				
				texmesh_R_1.text = enemySentecnesArray_2[Mathf.Floor(Random.Range(0,enemySentecnesArray_2.Length-.1))];
				
			}
			else
			{
				textRef_R_1.transform.position  = 	Vector3(100,100,0);
			}
			
		}
		else
		{
			textRef_R_1.transform.position = sentenceRef_R_1.position + Vector3((sentenceRef_R_1.position - this.transform.position).normalized.x * sentenceRef_R_1.localScale.x*.7, (sentenceRef_R_1.position - this.transform.position).normalized.y*.7 * sentenceRef_R_1.localScale.x , -1) ;
			textRef_R_1.transform.rotation = sentenceRef_R_1.rotation;
		}
		
		if( sentenceRef_R_2 == null)
		{
			if( (((Time.frameCount - lastTimeTextWasSet) >= delayBetweanTexting)) && (givenObject != null))
			{
				lastTimeTextWasSet = Time.frameCount;
				sentenceRef_R_2 = givenObject.transform;
				givenObject=null;
				
				texmesh_R_2.text = enemySentecnesArray_2[Mathf.Floor(Random.Range(0,enemySentecnesArray_2.Length-.1))];
			}
			else
			{
				textRef_R_2.transform.position  = 	Vector3(100,100,0);
			}
		}
		else
		{
			textRef_R_2.transform.position = sentenceRef_R_2.position + Vector3((sentenceRef_R_2.position - this.transform.position).normalized.x * sentenceRef_R_2.localScale.x*.7, (sentenceRef_R_2.position - this.transform.position).normalized.y*.7 * sentenceRef_R_2.localScale.x , -5) ;
			textRef_R_2.transform.rotation = sentenceRef_R_2.rotation;
		}
		
		if( sentenceRef_R_3 == null)
		{
			if( (((Time.frameCount - lastTimeTextWasSet) >= delayBetweanTexting)) && (givenObject!= null))
			{
				lastTimeTextWasSet = Time.frameCount;
				sentenceRef_R_3 = givenObject.transform;
				givenObject=null;
				
				texmesh_R_3.text = enemySentecnesArray_2[Mathf.Floor(Random.Range(0,enemySentecnesArray_2.Length-.1))];
			}
			else
			{
				textRef_R_3.transform.position  = 	Vector3(100,100,0);
			}
		}
		else
		{
			textRef_R_3.transform.position = sentenceRef_R_3.position + Vector3((sentenceRef_R_3.position - this.transform.position).normalized.x *.7* sentenceRef_R_3.localScale.x, (sentenceRef_R_3.position - this.transform.position).normalized.y*.7 * sentenceRef_R_3.localScale.x , -5) ;
			textRef_R_3.transform.rotation = sentenceRef_R_3.rotation;
		}
	}
}

function peopleSntences()
{
	
	//if(newEnemy != null)
	if(true)
	{
		
		if( sentenceRef_1 == null)
		{
			if( (((Time.frameCount - lastTimeTextWasSet) >= delayBetweanTexting)) && (newEnemy != null))
			{
				lastTimeTextWasSet = Time.frameCount;
				sentenceRef_1 = newEnemy.transform;
				newEnemy=null;
				
				texmesh_1.text = enemySentecnesArray_1[Mathf.Floor(Random.Range(0,enemySentecnesArray_1.Length-.1))];
			}
			else
			{
				textRef_1.transform.position  = 	Vector3(100,100,0);
			}
			
		}
		else
		{
			textRef_1.transform.position = sentenceRef_1.position + Vector3((sentenceRef_1.position - this.transform.position).normalized.x * sentenceRef_1.localScale.x*.7, (sentenceRef_1.position - this.transform.position).normalized.y*.7 * sentenceRef_1.localScale.x , -5) ;
			textRef_1.transform.rotation = sentenceRef_1.rotation;
		}
		
		if( sentenceRef_2 == null)
		{
			if( (((Time.frameCount - lastTimeTextWasSet) >= delayBetweanTexting)) && (newEnemy != null))
			{
				lastTimeTextWasSet = Time.frameCount;
				sentenceRef_2 = newEnemy.transform;
				newEnemy=null;
				
				texmesh_2.text = enemySentecnesArray_1[Mathf.Floor(Random.Range(0,enemySentecnesArray_1.Length-.1))];
			}
			else
			{
				textRef_2.transform.position  = 	Vector3(100,100,0);
			}
		}
		else
		{
			textRef_2.transform.position = sentenceRef_2.position + Vector3((sentenceRef_2.position - this.transform.position).normalized.x * sentenceRef_2.localScale.x*.7, (sentenceRef_2.position - this.transform.position).normalized.y*.7 * sentenceRef_2.localScale.x , -5) ;
			textRef_2.transform.rotation = sentenceRef_2.rotation;
		}
		
		if( sentenceRef_3 == null)
		{
			if( (((Time.frameCount - lastTimeTextWasSet) >= delayBetweanTexting)) && (newEnemy != null))
			{
				lastTimeTextWasSet = Time.frameCount;
				sentenceRef_3 = newEnemy.transform;
				newEnemy=null;
				
				texmesh_3.text = enemySentecnesArray_1[Mathf.Floor(Random.Range(0,enemySentecnesArray_1.Length-.1))];
			}
			else
			{
				textRef_3.transform.position  = 	Vector3(100,100,0);
			}
		}
		else
		{
			textRef_3.transform.position = sentenceRef_3.position + Vector3((sentenceRef_3.position - this.transform.position).normalized.x *.7* sentenceRef_3.localScale.x, (sentenceRef_3.position - this.transform.position).normalized.y*.7 * sentenceRef_3.localScale.x , -5) ;
			textRef_3.transform.rotation = sentenceRef_3.rotation;
		}
	}
}

function objectGenerator()
{
	RandomeNum = Random.insideUnitCircle;
	//Debug.Log( RandomeNum );
	if(Time.time - lastTimeAnEnemyWasCreated >= enemyGenerationTime)
	{
		newEnemy = Instantiate( enemyRefrence , RandomeNum*40 , this.transform.rotation );
		
		lastTimeAnEnemyWasCreated = Time.time;
		enemyGenerationPropertyChangeSpeed();
		
		for(var counter:int=0;counter< enemiesArray.Length; ++counter)
		{
			Debug.Log("0");
			if( enemiesArray[counter] == null )
			{
				Debug.Log("1");
				enemiesArray[counter] = newEnemy.transform;
				counter = enemiesArray.Length;
			}
		}
	}
}



